import { useSsrEffect } from '@issr/core';
import { useSelector, useDispatch } from 'react-redux';
import { fetchPost, updatePost } from './thunks';
import { PostState, Post } from '../../types/Post';

export const usePost = (postId: number): [boolean, boolean, Post] => {
  const dispatch = useDispatch();
  const { data, error, loading } = useSelector<{ post: PostState }, PostState>(state => state.post);

  useSsrEffect(() => dispatch(fetchPost(postId)));

  return [loading, error, data];
};

export const usePostApi = (): {
  updatePost: (post: { postId: number; title: string; text: string }) => void;
} => {
  const dispatch = useDispatch();
  return {
    updatePost: (post) => {
      dispatch(updatePost(post));
    },
  };
};
